'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2007
' by DotNetNuke Corporation
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'
Imports DotNetNuke
Imports DotNetNuke.Services.Exceptions
''' -----------------------------------------------------------------------------
''' Namespace:  RTP.RSSFeed
''' Project:    RTP.RSSFeed
''' Class:      Settings
''' -----------------------------------------------------------------------------
''' <summary>
''' The Settings ModuleSettingsBase is used to manage the 
''' settings for the RSSFeed Module
''' </summary>
''' <returns></returns>
''' <remarks>
''' </remarks>
''' <history>
'''		[RWJS]	03/07/2008	created
''' </history>
''' -----------------------------------------------------------------------------
Namespace RTP.RSSFeed

    Public MustInherit Class Settings
        Inherits Entities.Modules.ModuleSettingsBase

#Region " Web Form Designer Generated Code "

        'This call is required by the Web Form Designer.
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

        End Sub

        'The following placeholder declaration is required by the Web Form Designer.
        'Do not delete or move it.
        Private designerPlaceholderDeclaration As System.Object

        Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
            'CODEGEN: This method call is required by the Web Form Designer
            'Do not modify it using the code editor.
            InitializeComponent()
        End Sub

#End Region

#Region "Private Data"
#End Region

#Region "Help Methods"
        ' If adding new Setting also see 'SetDefaultModuleSettings' method in EventInfoHelper Class
        ''' <summary>
        ''' Load current settings from the database
        ''' </summary>
        ''' <remarks></remarks>
        Public Overrides Sub LoadSettings()

            ' Do we have to load the settings?
            If Not Page.IsPostBack Then
                Dim RSSSettings As New RSSSettings(ModuleId)
                If Me.UserInfo.IsSuperUser Then
                    Me.txtSQLQuery.Enabled = True
                Else
                    Me.txtSQLQuery.Enabled = False
                End If

                Me.txtFeedRootTitle.Text = RSSSettings.rssfeedroottitle
                Me.txtFeedRootDescription.Text = RSSSettings.rssfeedrootdescription
                chkTitle.Checked = RSSSettings.rssfeedtitle
                chkDescription.Checked = RSSSettings.rssfeeddescription
                chkLink.Checked = RSSSettings.rssfeedlink
                chkGuid.Checked = RSSSettings.rssfeedguid
                chkPubDate.Checked = RSSSettings.rssfeedpubdate
                chkCreator.Checked = RSSSettings.rssfeedcreator
                chkCategory.Checked = RSSSettings.rssfeedcategory
                chkImageURL.Checked = RSSSettings.rssimageurl
                Me.txtSQLQuery.Text = RSSSettings.rssfeedsqlquery
                chkSecurity.Checked = RSSSettings.rsssecurity
                Me.txtNoPerms.Text = RSSSettings.rssnoviewperms
                chkUTCConvert.Checked = RSSSettings.rssutcconvert
                Me.txtUTMSource.Text = RSSSettings.rssutmsource
                Me.txtUTMMedium.Text = RSSSettings.rssutmmedium

            End If
        End Sub
        ''' <summary>
        ''' Take all settings and write them back to the database
        ''' </summary>
        ''' <remarks></remarks>
        Public Overrides Sub UpdateSettings()
            Dim RSSSettings As New RSSSettings(ModuleId)

            Try
                RSSSettings.rssfeedroottitle = txtFeedRootTitle.Text.Trim
                RSSSettings.rssfeedrootdescription = txtFeedRootDescription.Text.Trim
                RSSSettings.rssfeedtitle = chkTitle.Checked
                RSSSettings.rssfeeddescription = chkDescription.Checked
                RSSSettings.rssfeedlink = chkLink.Checked
                RSSSettings.rssfeedguid = chkGuid.Checked
                RSSSettings.rssfeedpubdate = chkPubDate.Checked
                RSSSettings.rssfeedcreator = chkCreator.Checked
                RSSSettings.rssfeedcategory = chkCategory.Checked
                RSSSettings.rssimageurl = chkImageURL.Checked
                RSSSettings.rssfeedsqlquery = txtSQLQuery.Text.Trim
                RSSSettings.rsssecurity = chkSecurity.Checked
                RSSSettings.rssnoviewperms = txtNoPerms.Text.Trim
                RSSSettings.rssutcconvert = chkUTCConvert.Checked
                RSSSettings.rssutmsource = txtUTMSource.Text.Trim
                RSSSettings.rssutmmedium = txtUTMMedium.Text.Trim

                RSSSettings.SaveSettings(ModuleId)

            Catch exc As Exception 'Module failed to load
                ProcessModuleLoadException(Me, exc)
            End Try

        End Sub


#End Region

#Region "Links, Buttons and RSSFeed"
#End Region

    End Class


End Namespace
